diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/bindings/modulegen__gcc_LP64.py ns-3.31/src/lr-wpan/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -6730,7 +7478,95 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::McpsDataIndicationParams', 'arg0'), param('ns3::Ptr< ns3::Packet >', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+    return
+
+def register_Ns3CallbackImpl__Void_Ns3MlmeBeaconNotifyIndicationParams_Ns3Ptr__lt__ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::MlmeBeaconNotifyIndicationParams, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::MlmeBeaconNotifyIndicationParams arg0, ns3::Ptr<ns3::Packet> arg1) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::MlmeBeaconNotifyIndicationParams', 'arg0'), param('ns3::Ptr< ns3::Packet >', 'arg1')], 
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+    return
+
+def register_Ns3CallbackImpl__Void_Ns3MlmePollConfirmParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::MlmePollConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::MlmePollConfirmParams arg0) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::MlmePollConfirmParams', 'arg0')], 
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+    return
+
+def register_Ns3CallbackImpl__Void_Ns3MlmeStartConfirmParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::MlmeStartConfirmParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::MlmeStartConfirmParams arg0) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::MlmeStartConfirmParams', 'arg0')], 
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+    return
+
+def register_Ns3CallbackImpl__Void_Ns3MlmeSyncLossIndicationParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::MlmeSyncLossIndicationParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::MlmeSyncLossIndicationParams arg0) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::MlmeSyncLossIndicationParams', 'arg0')], 
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6752,7 +7588,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('double', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6774,7 +7610,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_char_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6796,7 +7632,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('unsigned char', 'arg1'), param('unsigned char', 'arg2')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6818,7 +7654,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6840,7 +7676,29 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+    return
+
+def register_Ns3CallbackImpl__Void_Ns3SuperframeStatus_Ns3SuperframeStatus_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::SuperframeStatus arg0, ns3::SuperframeStatus arg1) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::SuperframeStatus', 'arg0'), param('ns3::SuperframeStatus', 'arg1')], 
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Time_Ns3LrWpanPhyEnumeration_Ns3LrWpanPhyEnumeration_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6862,7 +7720,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Time', 'arg0'), param('ns3::LrWpanPhyEnumeration', 'arg1'), param('ns3::LrWpanPhyEnumeration', 'arg2')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6884,7 +7742,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3LrWpanNetDevice_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/examples/lr-wpan-data.cc ns-3.31/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.30.1/src/lr-wpan/examples/lr-wpan-data.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/examples/lr-wpan-data.cc	2020-06-27 17:38:30.000000000 -0700
@@ -61,7 +61,7 @@
   bool verbose = false;
   bool extended = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
 
   cmd.AddValue ("verbose", "turn on all log components", verbose);
   cmd.AddValue ("extended", "use extended addressing", extended);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.31/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.30.1/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2020-06-27 17:38:30.000000000 -0700
@@ -77,7 +77,7 @@
   double txPower = 0;
   uint32_t channelNumber = 11;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
 
   cmd.AddValue ("txPower", "transmit power (dBm)", txPower);
   cmd.AddValue ("packetSize", "packet (MSDU) size (bytes)", packetSize);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/examples/lr-wpan-mlme.cc ns-3.31/src/lr-wpan/examples/lr-wpan-mlme.cc
--- ns-3.30.1/src/lr-wpan/examples/lr-wpan-mlme.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/lr-wpan/examples/lr-wpan-mlme.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,211 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Ritsumeikan University, Shiga, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author:  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
+ */
+
+/*
+ *   Coordinator              End Device
+ *       N0   <----------------  N1
+ *      (dev0)                 (dev1)
+ *
+ * This example demonstrate the usage of the MAC primitives involved in
+ * direct transmissions for the beacon enabled mode of IEEE 802.15.4-2011.
+ * A single packet is sent from an end device to the coordinator during the CAP
+ * of the first incoming superframe.
+ *
+ * This example do not demonstrate a full protocol stack usage.
+ * For full protocol stack usage refer to 6lowpan examples.
+ *
+ */
+
+
+#include <ns3/log.h>
+#include <ns3/core-module.h>
+#include <ns3/lr-wpan-module.h>
+#include <ns3/propagation-loss-model.h>
+#include <ns3/propagation-delay-model.h>
+#include <ns3/simulator.h>
+#include <ns3/single-model-spectrum-channel.h>
+#include <ns3/constant-position-mobility-model.h>
+#include <ns3/packet.h>
+#include <iostream>
+
+using namespace ns3;
+
+static void BeaconIndication (MlmeBeaconNotifyIndicationParams params, Ptr<Packet> p)
+{
+  NS_LOG_UNCOND (Simulator::Now ().GetSeconds () << " secs | Received BEACON packet of size " << p->GetSize ());
+}
+
+static void DataIndication (McpsDataIndicationParams params, Ptr<Packet> p)
+{
+  NS_LOG_UNCOND (Simulator::Now ().GetSeconds () << " secs | Received DATA packet of size " << p->GetSize ());
+}
+
+static void TransEndIndication (McpsDataConfirmParams params)
+{
+  // In the case of transmissions with the Ack flag activated, the transaction is only
+  // successful if the Ack was received.
+  if (params.m_status == LrWpanMcpsDataConfirmStatus::IEEE_802_15_4_SUCCESS)
+    {
+      NS_LOG_UNCOND (Simulator::Now ().GetSeconds () << " secs | Transmission successfully sent");
+    }
+}
+
+static void DataIndicationCoordinator (McpsDataIndicationParams params, Ptr<Packet> p)
+{
+  NS_LOG_UNCOND (Simulator::Now ().GetSeconds () << "s Coordinator Received DATA packet (size " << p->GetSize () << " bytes)");
+}
+
+static void StartConfirm (MlmeStartConfirmParams params)
+{
+  if (params.m_status == MLMESTART_SUCCESS)
+    {
+      NS_LOG_UNCOND (Simulator::Now ().GetSeconds () << "Beacon status SUCESSFUL");
+    }
+}
+
+
+int main (int argc, char *argv[])
+{
+
+
+  LogComponentEnableAll (LOG_PREFIX_TIME);
+  LogComponentEnableAll (LOG_PREFIX_FUNC);
+  LogComponentEnable ("LrWpanMac", LOG_LEVEL_INFO);
+  LogComponentEnable ("LrWpanCsmaCa", LOG_LEVEL_INFO);
+
+
+  LrWpanHelper lrWpanHelper;
+
+  // Create 2 nodes, and a NetDevice for each one
+  Ptr<Node> n0 = CreateObject <Node> ();
+  Ptr<Node> n1 = CreateObject <Node> ();
+
+  Ptr<LrWpanNetDevice> dev0 = CreateObject<LrWpanNetDevice> ();
+  Ptr<LrWpanNetDevice> dev1 = CreateObject<LrWpanNetDevice> ();
+
+  dev0->SetAddress (Mac16Address ("00:01"));
+  dev1->SetAddress (Mac16Address ("00:02"));
+
+  Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel> ();
+  Ptr<LogDistancePropagationLossModel> propModel = CreateObject<LogDistancePropagationLossModel> ();
+  Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
+  channel->AddPropagationLossModel (propModel);
+  channel->SetPropagationDelayModel (delayModel);
+
+  dev0->SetChannel (channel);
+  dev1->SetChannel (channel);
+
+  n0->AddDevice (dev0);
+  n1->AddDevice (dev1);
+
+  ///////////////// Mobility   ///////////////////////
+  Ptr<ConstantPositionMobilityModel> sender0Mobility = CreateObject<ConstantPositionMobilityModel> ();
+  sender0Mobility->SetPosition (Vector (0,0,0));
+  dev0->GetPhy ()->SetMobility (sender0Mobility);
+  Ptr<ConstantPositionMobilityModel> sender1Mobility = CreateObject<ConstantPositionMobilityModel> ();
+
+  sender1Mobility->SetPosition (Vector (0,10,0)); //10 m distance
+  dev1->GetPhy ()->SetMobility (sender1Mobility);
+
+
+  /////// MAC layer Callbacks hooks/////////////
+
+  MlmeStartConfirmCallback cb0;
+  cb0 = MakeCallback (&StartConfirm);
+  dev0->GetMac ()->SetMlmeStartConfirmCallback (cb0);
+
+  McpsDataConfirmCallback cb1;
+  cb1 = MakeCallback (&TransEndIndication);
+  dev1->GetMac ()->SetMcpsDataConfirmCallback (cb1);
+
+  MlmeBeaconNotifyIndicationCallback cb3;
+  cb3 = MakeCallback (&BeaconIndication);
+  dev1->GetMac ()->SetMlmeBeaconNotifyIndicationCallback (cb3);
+
+  McpsDataIndicationCallback cb4;
+  cb4 = MakeCallback (&DataIndication);
+  dev1->GetMac ()->SetMcpsDataIndicationCallback (cb4);
+
+  McpsDataIndicationCallback cb5;
+  cb5 = MakeCallback (&DataIndicationCoordinator);
+  dev0->GetMac ()->SetMcpsDataIndicationCallback (cb5);
+
+
+
+  //////////// Manual device association ////////////////////
+  // Note: We manually associate the devices to a PAN coordinator
+  //       because currently there is no automatic association behavior (bootstrap);
+  //       The PAN COORDINATOR does not need to associate or set its
+  //       PAN Id or its own coordinator id, these are set
+  //       by the MLME-start.request primitive when used.
+
+  dev1->GetMac ()->SetPanId (5);
+  dev1->GetMac ()->SetAssociatedCoor (Mac16Address ("00:01"));
+
+
+
+  ///////////////////// Start transmitting beacons from coordinator ////////////////////////
+
+  MlmeStartRequestParams params;
+  params.m_panCoor = true;
+  params.m_PanId = 5;
+  params.m_bcnOrd = 14;
+  params.m_sfrmOrd = 6;
+  Simulator::ScheduleWithContext (1, Seconds (2.0),
+                                  &LrWpanMac::MlmeStartRequest,
+                                  dev0->GetMac (), params);
+
+  ///////////////////// Transmission of data Packets from end device //////////////////////
+
+  Ptr<Packet> p1 = Create<Packet> (5);
+  McpsDataRequestParams params2;
+  params2.m_dstPanId = 5;
+  params2.m_srcAddrMode = SHORT_ADDR;
+  params2.m_dstAddrMode = SHORT_ADDR;
+  params2.m_dstAddr = Mac16Address ("00:01");
+  params2.m_msduHandle = 0;
+  // params2.m_txOptions = TX_OPTION_ACK;  // Enable direct transmission with Ack
+
+  /////////////////////////////////////////////////////////////////////////////////////
+  // Examples of time parameters for transmissions in the first incoming superframe. //
+  /////////////////////////////////////////////////////////////////////////////////////
+
+  // 2.981 sec      No time to finish CCA in CAP, the transmission at this time will cause
+  //                the packet to be deferred to the next superframe.
+
+  // 2.982 sec      No time to finish random backoff delay in CAP, the  transmission at this
+  //                time will cause the packet to be deferred to the next superframe.
+
+  // 2.93 sec       Enough time, the packet can be transmitted within the CAP of the first superframe
+
+
+  // MCPS-DATA.request Beacon enabled Direct Transmission (dev1)
+  // Frame transmission from End Device to Coordinator (Direct transmission)
+  Simulator::ScheduleWithContext (1, Seconds (2.93),
+                                  &LrWpanMac::McpsDataRequest,
+                                  dev1->GetMac (), params2, p1);
+
+
+  Simulator::Stop (Seconds (600));
+  Simulator::Run ();
+
+  Simulator::Destroy ();
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/examples/lr-wpan-phy-test.cc ns-3.31/src/lr-wpan/examples/lr-wpan-phy-test.cc
--- ns-3.30.1/src/lr-wpan/examples/lr-wpan-phy-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/examples/lr-wpan-phy-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,7 +55,7 @@
 
 int main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   LogComponentEnableAll (LOG_PREFIX_FUNC);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/examples/wscript ns-3.31/src/lr-wpan/examples/wscript
--- ns-3.30.1/src/lr-wpan/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -15,3 +15,6 @@
 
     obj = bld.create_ns3_program('lr-wpan-error-distance-plot', ['lr-wpan', 'stats'])
     obj.source = 'lr-wpan-error-distance-plot.cc'
+    
+    obj = bld.create_ns3_program('lr-wpan-mlme', ['lr-wpan'])
+    obj.source = 'lr-wpan-mlme.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/helper/lr-wpan-helper.cc ns-3.31/src/lr-wpan/helper/lr-wpan-helper.cc
--- ns-3.30.1/src/lr-wpan/helper/lr-wpan-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/helper/lr-wpan-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -254,6 +254,63 @@
   return;
 }
 
+void
+LrWpanHelper::AssociateToBeaconPan (NetDeviceContainer c, uint16_t panId, Mac16Address coor, uint8_t bcnOrd, uint8_t sfrmOrd)
+{
+  NetDeviceContainer devices;
+  uint16_t id = 1;
+  uint8_t idBuf[2];
+  Mac16Address address;
+
+  if (bcnOrd > 14)
+    {
+      NS_LOG_DEBUG("The Beacon Order must be an int between 0 and 14");
+      return;
+    }
+
+
+  if ((sfrmOrd > 14) || (sfrmOrd > bcnOrd))
+    {
+      NS_LOG_DEBUG("The Superframe Order must be an int between 0 and 14, and less or equal to Beacon Order");
+      return;
+    }
+
+  for (NetDeviceContainer::Iterator i = c.Begin (); i != c.End (); i++)
+    {
+      Ptr<LrWpanNetDevice> device = DynamicCast<LrWpanNetDevice> (*i);
+      if (device)
+        {
+          idBuf[0] = (id >> 8) & 0xff;
+          idBuf[1] = (id >> 0) & 0xff;
+          address.CopyFrom (idBuf);
+
+          device->GetMac ()->SetShortAddress (address);
+
+          if (address == coor)
+            {
+              MlmeStartRequestParams params;
+              params.m_panCoor = true;
+              params.m_PanId = panId;
+              params.m_bcnOrd = bcnOrd;
+              params.m_sfrmOrd = sfrmOrd;
+
+              Ptr<UniformRandomVariable> uniformRandomVariable = CreateObject<UniformRandomVariable> ();;
+              Time jitter = Time (MilliSeconds (uniformRandomVariable->GetInteger (0, 10)));
+
+              Simulator::Schedule (jitter, &LrWpanMac::MlmeStartRequest,
+                                              device->GetMac (), params);
+            }
+          else
+            {
+              device->GetMac ()->SetPanId (panId);
+              device->GetMac ()->SetAssociatedCoor(coor);
+            }
+          id++;
+        }
+    }
+  return;
+}
+
 /**
  * @brief Write a packet in a PCAP file
  * @param file the output file
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/helper/lr-wpan-helper.h ns-3.31/src/lr-wpan/helper/lr-wpan-helper.h
--- ns-3.30.1/src/lr-wpan/helper/lr-wpan-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/helper/lr-wpan-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -113,6 +113,19 @@
   void AssociateToPan (NetDeviceContainer c, uint16_t panId);
 
   /**
+   * \brief Associate the nodes to the same PAN and initiate beacon enabled mode.
+   *
+   * \param c a set of nodes
+   * \param panID the PAN id
+   * \param coor the address of the PAN coordinator
+   * \param bcnOrd indicates the interval between beacons.
+   *               The value must be an int between 0 and 14.
+   * \param sfrmOrd indicates the length of the superframe.
+   *                The value must be an int between 0 and 14 and less or equal to the bcnOrd
+   */
+  void AssociateToBeaconPan (NetDeviceContainer c, uint16_t panId, Mac16Address coor, uint8_t bcnOrd, uint8_t sfrmOrd);
+
+  /**
    * Helper to enable all LrWpan log components with one statement
    */
   void EnableLogComponents (void);
